#pragma once

#include <Punkt.h>
#include <ReferenceCounter.h>
#include <Reader.h>
#include <Either.h>

#include "Area.h"

class Block;

class Chunk : public virtual Framework::ReferenceCounter
{
private:
    int dimensionId;
    Framework::Punkt location;
    Block** blocks;
    unsigned short* blockIds;
    Chunk* zNeighbours[ 4 ];
    Framework::Either<Block*, int> zBlockNeighbor( Framework::Vec3<int> location );
    bool added;

public:
    Chunk( Framework::Punkt location, int dimensionId );
    Chunk( Framework::Punkt location, int dimensionId, Framework::StreamReader* zReader );
    ~Chunk();
    bool updateVisibility();
    Framework::Either<Block*, int> zBlockAt( Framework::Vec3<int> cLocation ) const;
    const Block* zBlockConst( Framework::Vec3<int> location ) const;
    void putBlockAt( Framework::Vec3<int> location, Block* block );
    void putBlockTypeAt( Framework::Vec3<int> location, int type );
    void setNeighbor( Direction dir, Chunk* zChunk );
    void load( Framework::StreamReader* zReader );
    int getDimensionId() const;
    Framework::Punkt getCenter() const;
    Framework::Vec3<int> getMin() const;
    Framework::Vec3<int> getMax() const;
    void prepareRemove();
    void setAdded();
};